// VSNetHelp.cpp : Defines the initialization routines for the DLL.
//

#include "stdafx.h"
#include <initguid.h>
#include "VSNetHelp.h"
#include "DSAddIn.h"
#include "Commands.h"

ATL::CComModule _Module; 

BEGIN_OBJECT_MAP(ObjectMap)
    OBJECT_ENTRY(CLSID_DSAddIn, CDSAddIn)
END_OBJECT_MAP()



extern "C"
BOOL WINAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID /*lpReserved*/)
{
    if (dwReason == DLL_PROCESS_ATTACH)
    {
        _Module.Init(ObjectMap, hInstance);
        DisableThreadLibraryCalls(hInstance);
    }
    else if (dwReason == DLL_PROCESS_DETACH)
        _Module.Term();
    return TRUE;    // ok
}

/////////////////////////////////////////////////////////////////////////////
// Special entry points required for inproc servers

STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv)
{
    return _Module.GetClassObject(rclsid, riid, ppv);
}

STDAPI DllCanUnloadNow(void)
{
    return (_Module.GetLockCount()==0) ? S_OK : S_FALSE;
}

// by exporting DllRegisterServer, you can use regsvr32.exe
STDAPI DllRegisterServer(void)
{
    HRESULT hRes = S_OK;

    // Registers object, typelib and all interfaces in typelib
    hRes = _Module.RegisterServer(TRUE);
    if (FAILED(hRes))
        return hRes;

    // Register description of this add-in object in its own
    //  "/Description" subkey.
    // TODO:  If you add more add-ins to this module, you need
    //  to register all of their descriptions, each description
    //  in each add-in object's registry CLSID entry:
    // HKEY_CLASSES_ROOT\Clsid\{add-in CLSID}\Description="add-in description"
    _ATL_OBJMAP_ENTRY* pEntry = _Module.m_pObjMap;
    CRegKey key;
    LONG lRes = key.Open(HKEY_CLASSES_ROOT, _T("CLSID"));
    if (lRes == ERROR_SUCCESS)
    {
        USES_CONVERSION;
        LPOLESTR lpOleStr = NULL;
        StringFromCLSID(*pEntry->pclsid, &lpOleStr);
        LPTSTR lpsz = OLE2T(lpOleStr);

        lRes = key.Open(key, lpsz);
        if (lRes == ERROR_SUCCESS)
        {
            CComBSTR strDescription;
            strDescription.LoadString(IDS_VSNETHELP_DESCRIPTION);
            key.SetKeyValue(_T("Description"),  OLE2CT( (BSTR) strDescription)); 
        }
        ::CoTaskMemFree(lpOleStr);
    }
    if (lRes != ERROR_SUCCESS)
        hRes = HRESULT_FROM_WIN32(lRes);

    return hRes;
}

/////////////////////////////////////////////////////////////////////////////
// DllUnregisterServer - Removes entries from the system registry

STDAPI DllUnregisterServer(void)
{
    HRESULT hRes = S_OK;
    _Module.UnregisterServer();
    return hRes;
}


/////////////////////////////////////////////////////////////////////////////
// Debugging support

// GetLastErrorDescription is used in the implementation of the VERIFY_OK
//  macro, defined in stdafx.h.

#ifdef _DEBUG

void GetLastErrorDescription(CComBSTR& bstr)
{
    CComPtr<IErrorInfo> pErrorInfo;
    if (GetErrorInfo(0, (IErrorInfo**) &pErrorInfo) == S_OK) { 
        pErrorInfo->GetDescription(&bstr); 
    } 
}

#endif //_DEBUG
